diff --git a/changelog b/changelog
index 1fa19a3..72812f4 100644
--- a/changelog
+++ b/changelog
@@ -1,3 +1,6 @@
+20120113 rhx src/axiom-website/patches.html 20120113.01.rhx.patch
+20121113 rhx src/input/Makefile add i2e.input
+20120113 rhx src/input/i2e.input demo InputForm to Expression(Integer)
 20120102 tpd src/axiom-website/patches.html 20120102.01.tpd.patch
 20120101 tpd src/interp/br-con.lisp treeshake compiler
 20120101 tpd books/bookvol9 treeshake compiler
diff --git a/src/axiom-website/patches.html b/src/axiom-website/patches.html
index 86c2806..4765769 100644
--- a/src/axiom-website/patches.html
+++ b/src/axiom-website/patches.html
@@ -3761,5 +3761,7 @@ books/bookvol9 treeshake compiler<br/>
 books/bookvol9 treeshake compiler<br/>
 <a href="patches/20120102.01.tpd.patch">20120102.01.tpd.patch</a>
 books/bookvol9 treeshake compiler<br/>
+<a href="patches/20120113.01.rhx.patch">20120113.01.rhx.patch</a>
+src/input/i2e.input demo InputForm to Expression(Integer)<br/>
  </body>
 </html>
diff --git a/src/input/Makefile.pamphlet b/src/input/Makefile.pamphlet
index 3c7b96a..553b359 100644
--- a/src/input/Makefile.pamphlet
+++ b/src/input/Makefile.pamphlet
@@ -343,7 +343,7 @@ REGRESSTESTS= ackermann.regress \
     herm.regress      heugcd.regress \
     hexadec.regress   hyperbolicrules.regress  \
     hyperell.regress  ico.regress       ideal.regress \
-    ifact.regress     ifthenelse.regress \
+    ifact.regress     ifthenelse.regress i2e.regress \
     infprod.regress   intaf.regress    intbypart.regress \
     intdeq.regress \
     intef2.regress    intef.regress    intg0.regress    intheory.regress \
@@ -701,7 +701,7 @@ FILES= ${OUT}/ackermann.input \
        ${OUT}/hyperbolicrules.input \
        ${OUT}/hyperell.input \
        ${OUT}/ico.input      ${OUT}/ideal.input      ${OUT}/ifact.input \
-       ${OUT}/ifthenelse.input \
+       ${OUT}/ifthenelse.input ${OUT}/i2e.input \
        ${OUT}/images1.input  ${OUT}/images1a.input   ${OUT}/images3a.input \
        ${OUT}/images3.input  ${OUT}/images6.input    ${OUT}/images6a.input \
        ${OUT}/images7.input  ${OUT}/images7a.input   ${OUT}/infprod.input \
@@ -1065,7 +1065,7 @@ DOCFILES= \
   ${DOC}/hyperell.input.dvi   \
   ${DOC}/ico.input.dvi        \
   ${DOC}/ideal.input.dvi       ${DOC}/ifact.input.dvi      \
-  ${DOC}/ifthenelse.input.dvi \
+  ${DOC}/ifthenelse.input.dvi  ${DOC}/i2e.input.dvi        \
   ${DOC}/images1a.input.dvi    ${DOC}/images1.input.dvi    \
   ${DOC}/images2a.input.dvi    ${DOC}/images2.input.dvi    \
   ${DOC}/images3a.input.dvi    ${DOC}/images3.input.dvi    \
diff --git a/src/input/i2e.input.pamphlet b/src/input/i2e.input.pamphlet
new file mode 100644
index 0000000..9c85943
--- /dev/null
+++ b/src/input/i2e.input.pamphlet
@@ -0,0 +1,76 @@
+\documentclass{article}
+\usepackage{axiom}
+\setlength{\textwidth}{400pt}
+\begin{document}
+\title{\$SPAD/src/input algaggr.input}
+\author{Ralf Hemmecke}
+\maketitle
+\begin{abstract}
+When entering a function on the command line you will most probably get
+Expression(Integer) as the result type.
+
+This is a path to convert an Expression(Integer) to InputForm and back.
+\end{abstract}
+\eject
+\tableofcontents
+\eject
+\begin{chunk}{*}
+)set break resume
+)spool i2e.output
+)set message test on
+)set message auto off
+)clear all
+ 
+--S 1 of 6
+ex:=sin(cos(x+2)+3)+exp(x+2)+sqrt(x)
+--R
+--R                               +-+     x + 2
+--R   (1)  sin(cos(x + 2) + 3) + \|x  + %e
+--R                                                     Type: Expression Integer
+--E 1
+
+--S 2 of 6
+exi:=ex::InputForm
+--R
+--R   (2)  (+ (sin (+ (cos (+ x 2)) 3)) (+ (** x (/ 1 2)) (exp (+ x 2))))
+--R                                                              Type: InputForm
+--E 2
+
+--S 3 of 6
+d1:=destruct exi
+--R
+--R   (3)  [+,(sin (+ (cos (+ x 2)) 3)),(+ (** x (/ 1 2)) (exp (+ x 2)))]
+--R                                                         Type: List InputForm
+--E 3
+
+--S 4 of 6
+l2:=[first d1, first rest d1, first rest destruct first rest rest d1]
+--R
+--R   (4)  [+,(sin (+ (cos (+ x 2)) 3)),(** x (/ 1 2))]
+--R                                                         Type: List InputForm
+--E 4
+
+--S 5 of 6
+inf:=convert l2
+--R
+--R   (5)  (+ (sin (+ (cos (+ x 2)) 3)) (** x (/ 1 2)))
+--R                                                              Type: InputForm
+--E 5
+
+--S 6 of 6
+interpret inf
+--R
+--R                               +-+
+--R   (6)  sin(cos(x + 2) + 3) + \|x
+--R                                                     Type: Expression Integer
+--E 6
+
+)spool
+)lisp (bye)
+ 
+\end{chunk}
+\eject
+\begin{thebibliography}{99}
+\bibitem{1} nothing
+\end{thebibliography}
+\end{document}
